#include "STC8H.H"
#include "define.h"
#include "stc32_stc8_usb.h"
#include <intrins.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#define		MAIN_Fosc	22118400UL   //ʱ

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";	//ԶλISPûӿ

bit I2C_Busy;
bit Flag;

void Delay_10ms(void)
{
	unsigned char data i, j, k;

	i = 2;
	j = 32;
	k = 60;
	do
	{
		do
		{
			while (--k);
		} while (--j);
	} while (--i);
}

void Delay_x10ms(unsigned char x)
{
	while(--x)
		Delay_10ms();
}

void CDC_Printf(const char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(bUsbInBusy)
		P34=0;
	P34=1;
	USB_SendData(UsbInBuffer,vsprintf(UsbInBuffer,v,ap));
	va_end(ap);
}

void Data_Printf(void)
{
	unsigned int i=0x5A;
	if(Flag)
	{
		Flag=0;
		if(P32)
			return;
		CDC_Printf("%02bX %02bX %02bX %02bX %02bX %02bX %02bX %02bX %02bX %02bX \r\n",(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i,(unsigned char)i);
	}
}

BOOL usb_OUT_callback()
{
//	USB_SendData(UsbOutBuffer,OutNumber);
	return 1;
}

void Init(void)
{
	P_SW2|=0x80;	//չĴ(XFR)ʹ
	P0M0=0x00; P0M1=0x00; 
	P1M0=0x00; P1M1=0x00; 
	P2M0=0x00; P2M1=0x00; 
	P3M0=0x00; P3M1=0x00; 
	P4M0=0x00; P4M1=0x00; 
	P5M0=0x00; P5M1=0x00; 
	P6M0=0x00; P6M1=0x00; 
	P7M0=0x00; P7M1=0x00; 
	P1PU=0x30;
	
	IRC48MCR=0x80;
	while(!(IRC48MCR&0x01));
	USBCLK=0x00;
	USBCON=0x90;
	usb_init();
	IE2|=0x80;			//IE2صжλʹܺҪEUSB
	
	AUXR &= 0x7F;			//ʱʱ12Tģʽ
	TMOD &= 0xF0;			//öʱģʽ
	TL0 = 0x00;				//öʱʼֵ
	TH0 = 0xB8;				//öʱʼֵ
	TF0 = 0;				//TF0־
	TR0 = 1;				//ʱ0ʼʱ
	ET0 = 1;				//ʹܶʱ0ж
	
	I2CCFG=0xD2;	//394.9714286K@22.1184M
	I2CMSCR=EMSI;
	I2CMSST=0x00;
	Delay_x10ms(10);
	
    EA=1;
	memset(UsbInBuffer,0x00,sizeof UsbInBuffer);
}

void main(void)
{
	Init();
	while(1)
	{
		if(DeviceState!=DEVSTATE_CONFIGURED)  //ȴUSB
            continue;
		Data_Printf();
	}
}

void Timer0_Isr(void) interrupt 1
{
	static unsigned char i;
	i++;
	if(i==1)
	{
		i=0;
		Flag=1;
	}
}

void I2C_Isr(void) interrupt 13	//ӳж
{
	if(I2CMSST&MSIF)
	{
		I2CMSST&=~MSIF;
		I2C_Busy=0;
	}
}